#include <stdio.h>
#include <stdbool.h>


struct date {
  int day;
  int month;
  int year;
};

bool checkDate(struct date d);
void updateDate(struct date *d);
int max_days(struct date d);

// ============================================================================

int main(void) {
  struct date d;
  bool correct;
  
  do{
    printf("Inserire una data nel formato dd/mm/yyyy: ");
    scanf("%i/%i/%i", &d.day, &d.month, &d.year);
    correct = checkDate(d);
  } while(correct == false);

  updateDate(&d);
  printf("La data aggiornata e': %.2i/%.2i/%.4i\n", d.day, d.month, d.year);

  return 0;
}

/**
 * Funzione che ritorna true se la data e' valida, false altrimenti.
 */
bool checkDate(struct date d) {
  if (d.month < 1 || d.month > 12) {
    return false;
  }
  if (d.day < 1 || d.day > max_days(d)) {
    return false;
  }
  return true;
}

/**
 * Funzione che aggiunge 10 giorni alla data passata come parametro.
 */
void updateDate(struct date *d) {
  int n = d->day + 10;
  int max_d = max_days(*d);
  
  if (n < max_d) {
    d->day = d->day + 10;
  } else {
    d->day = n - max_d;
    if (d->month < 12) {
      d->month++;
    } else {
      d->month = 1;
      d->year++;
    }
  }
}

/**
 * Funzione che ritorna il massimo numero di giorni nel mese.
 */
int max_days(struct date d) {
  if (d.month == 1 || d.month == 3 || d.month == 5 || d.month == 7 ||
      d.month == 8 || d.month == 10 || d.month == 12) {
    return 31;
  } else if (d.month == 4 || d.month == 6 || d.month == 9 || d.month == 11) {
    return 30;
  } else {
    if (d.year % 4 == 0 && ( d.year % 100 != 0 || d.year % 400 == 0 )) {
      return 29;
    } else {
      return 28;
    }
  }
}
